import java.lang.*;
import java.util.*;

class LiteTester implements Runnable {

	private TrafficLiteSimulator trafficLiteSimulator_;
	public TrafficLiteSimulator trafficLiteSimulator() { return trafficLiteSimulator_; }
	public void trafficLiteSimulator( TrafficLiteSimulator aTrafficLiteSimulator ) { trafficLiteSimulator_ = aTrafficLiteSimulator; }

    private boolean busy_;
    public boolean busy() { return busy_ ; }
    public void busy(boolean aBoolean) { busy_ = aBoolean ; }

    private boolean done_;
    public boolean done() { return done_ ; }
    public void done(boolean aBoolean) { done_ = aBoolean ; }

    private Thread thread_;
    public Thread thread() { return thread_ ; }
    public void thread(Thread aThread) { thread_ = aThread ; }


    public LiteTester(TrafficLiteSimulator aTLS) {
        this.trafficLiteSimulator(aTLS);
        this.busy(false);
        this.done(false);
        this.thread(new Thread(this));
        this.thread().start();
    }

    public void run() {


        while (!this.done()) {
            this.sequentialTest();
        }
        this.busy(false);
    }

    public void sequentialTest() {

        TrafficLiteSimulator theTLS = this.trafficLiteSimulator();

        theTLS.nPedLite("walk");
        this.pauseALittle();
        theTLS.nPedLite("dontwalk");
        this.pauseALittle();
        theTLS.nPedLite("dark");

        theTLS.sPedLite("walk");
        this.pauseALittle();
        theTLS.sPedLite("dontwalk");
        this.pauseALittle();
        theTLS.sPedLite("dark");

        theTLS.ePedLite("walk");
        this.pauseALittle();
        theTLS.ePedLite("dontwalk");
        this.pauseALittle();
        theTLS.ePedLite("dark");

        theTLS.wPedLite("walk");
        this.pauseALittle();
        theTLS.wPedLite("dontwalk");
        this.pauseALittle();
        theTLS.wPedLite("dark");

        theTLS.northThruLite("green");
        this.pauseALittle();
        theTLS.northThruLite("yellow");
        this.pauseALittle();
        theTLS.northThruLite("red");
        this.pauseALittle();
        theTLS.northThruLite("dark");
        this.pauseALittle();

        theTLS.northLeftLite("green");
        this.pauseALittle();
        theTLS.northLeftLite("yellow");
        this.pauseALittle();
        theTLS.northLeftLite("red");
        this.pauseALittle();
        theTLS.northLeftLite("dark");
        this.pauseALittle();

        theTLS.southThruLite("green");
        this.pauseALittle();
        theTLS.southThruLite("yellow");
        this.pauseALittle();
        theTLS.southThruLite("red");
        this.pauseALittle();
        theTLS.southThruLite("dark");
        this.pauseALittle();

        theTLS.southLeftLite("green");
        this.pauseALittle();
        theTLS.southLeftLite("yellow");
        this.pauseALittle();
        theTLS.southLeftLite("red");
        this.pauseALittle();
        theTLS.southLeftLite("dark");
        this.pauseALittle();

        theTLS.eastThruLite("green");
        this.pauseALittle();
        theTLS.eastThruLite("yellow");
        this.pauseALittle();
        theTLS.eastThruLite("red");
        this.pauseALittle();
        theTLS.eastThruLite("dark");
        this.pauseALittle();


        theTLS.eastLeftLite("green");
        this.pauseALittle();
        theTLS.eastLeftLite("yellow");
        this.pauseALittle();
        theTLS.eastLeftLite("red");
        this.pauseALittle();
        theTLS.eastLeftLite("dark");
        this.pauseALittle();


        theTLS.westThruLite("green");
        this.pauseALittle();
        theTLS.westThruLite("yellow");
        this.pauseALittle();
        theTLS.westThruLite("red");
        this.pauseALittle();
        theTLS.westThruLite("dark");
        this.pauseALittle();

        theTLS.westLeftLite("green");
        this.pauseALittle();
        theTLS.westLeftLite("yellow");
        this.pauseALittle();
        theTLS.westLeftLite("red");
        this.pauseALittle();
        theTLS.westLeftLite("dark");
        this.pauseALittle();


    }

    public void pauseALittle() {

        try {
            Thread.sleep(200);
        }
        catch (InterruptedException e) {
            System.out.println("Uh..oh .. LiteTester.pauseALittle");
        }
    }
}

